//Used to set the X-, Y- or Z-Register to a Ram address
// Example: SetRamPointer X, MyRamAddress
.MACRO SetRamPointer
	ldi @0H, High(@1)
	ldi @0L, Low(@1)
.ENDMACRO



//********************************************************
// Used for jumping in async state tables.
// PrepareJump: Prepares a jump called by Jump-Macro
// @0: 2 Byte Ram Address
// @1: Next Label to Jump
.MACRO PrepareJump
	push d0
	ldi d0, high(@1)
	sts @0, d0
	ldi d0, low(@1)
	sts @0 +1, d0
	pop d0
.ENDMACRO


// Jump: Executes a jump prepared by PrepareJump-Macro
// @0: 2 Byte Ram Address
.MACRO Jump
	lds ZH, @0
	lds ZL, @0 +1	
	ijmp
.ENDMACRO
//********************************************************




/*
.MACRO Increment16BitRAMCell
	push XL
	push XH
	lds XH, @0
	lds XL, @0+1

	adiw X, 1

	sts @0, XH
	sts @0+1, XL
	
	pop XH
	pop XL
.ENDMACRO

.MACRO Decrement16BitRAMCell
	push XL
	push XH
	lds XH, @0
	lds XL, @0+1

	sbiw X, 1

	sts @0, XH
	sts @0+1, XL
	
	pop XH
	pop XL
.ENDMACRO



.MACRO MAC_Compare16BitRAM
	push d1
	push d2
	push d3
	lds d1, @0
	lds d0, @0+1
	lds d3, @1
	lds d2, @1+1
	call Compare16BitRegisters
	pop d3
	pop d2
	pop d1
.ENDMACRO
*/

//***********************************************************************
//Compare 16 Bit RAM registers
//Returns in d0:
// 	0: 	d1/d0 = d3/d2
// 	1: 	d1/d0 > d3/d2
// 	FF: d1/d0 < d3/d2
//***********************************************************************
/*
Compare16BitRegisters:
	cp d1, d3
	breq Compare16BitRegisters_LowerByte
	brsh Compare16BitRegisters_IsHigher
	ldi d0, 0xFF
	ret

Compare16BitRegisters_IsHigher:
	ldi d0, 0x01
	ret

Compare16BitRegisters_IsSame:
	clr d0
	ret

Compare16BitRegisters_LowerByte:
	cp d0, d2
	breq Compare16BitRegisters_IsSame
	brsh Compare16BitRegisters_IsHigher
	ldi d0, 0xFF
	ret

*/











