//***********************************************************************
// Common module for rs232 communication
//***********************************************************************





;******************************************
;Init
;******************************************
INIT_COM:
	;Baudrate


	///***********
	// 9600 Baud
	///***********
	ldi d1, 0
	ldi d0, 51 
	sts UBRR0H, d1
	sts UBRR0L, d0
	//END OF 9600 Baud





	///***********
	// 19200 Baud
	///***********
	//ldi d1, 0
	//ldi d0, 25 
	//sts UBRR0H, d1
	//sts UBRR0L, d0


	//END OF 19200 Baud


	///***********
	/// 38400 Baud
	///***********
	//ldi d1, 0
	//ldi d0, 12 
	//sts UBRR0H, d1
	//sts UBRR0L, d0
	//END OF 38400 Baud



	///***************************************
	// 57600 Baud with double speed flag set
	///***************************************
	//Double speed on
	
	//ldi d0, (1<<U2X0) 
	//sts UCSR0A, d0


	// Set Baud rate registers
	//ldi d1, 0
	//ldi d0, 16
	//sts UBRR0H, d1
	//sts UBRR0L, d0
	// END OF 57600 Baud with double speed flag set







	// Set frame format: 8data, 1 Stop bit, no parity
	ldi d0, (1<<UCSZ01)+(1<<UCSZ00)
	sts UCSR0C, d0





	

	cli
	//Transmitter/Receiver enabled/interrupt enabled
	ldi d0, (1<<TXCIE0) + (1<<RXCIE0) + (1<<TXEN0) + (1<<RXEN0)	
	sts UCSR0B, d0


//INIT_COM_ByteTest: //Endless loop byte testing
	//call CheckHC06BaudRate


	sei

	ret



;******************************************
;RxD
;******************************************
RxD_Interrupt:
	;Register retten
	push d0
	in d0, SREG
	push d0
	push d1
	push d2
	push d3
	push XL
	push XH
	push YL
	push YH
	push ZL
	push ZH

	call RxDInterruptService
	
	;Register zurckholen
	pop ZH
	pop ZL
	pop YH
	pop YL
	pop XH
	pop XL
	pop d3
	pop d2
	pop d1
	pop d0
	out SREG, d0	
	pop d0
	reti


		




//*********************************************************************************
//TXD
//*********************************************************************************
TxDSendByte:
	rcall WaitForEmptyTxDBuffer
	rcall TxDTransmitByte
	ret

	
WaitForEmptyTxDBuffer:
	//Wait for empty transmit buffer
	push d0
	lds d0, UCSR0A
	sbrs d0, UDRE0
	rjmp WaitForEmptyTxDBuffer

	pop d0
	ret




TxDTransmitByte:
	//DataByte is assumed in d0
	// Before Transmission d0 is added to checksum

	sts UDR0, d0
	ret		


TxD_Interrupt:
	;Register retten
	push d0
	in d0, SREG
	push d0
	push d1
	push d2
	push XL
	push XH
	push YL
	push YH
	push ZL
	push ZH
	call TxDInterruptService
	//nop
	;Register zurckholen
	pop ZH
	pop ZL
	pop YH
	pop YL
	pop XH
	pop XL
	pop d2
	pop d1
	pop d0
	out SREG, d0	
	pop d0
	reti






//***************************************************************************
// COMMON
//***************************************************************************

MakeChecksumOfByte:
	;erwartet das Byte in d0, gibt die Checksumme in d1 wieder
	push d2 
	ldi d2, 8
	clr d1
MakeChecksumOfByte_Loop:
	sbrc d0, 0
	inc d1
	ror d0
	dec d2
	brne MakeChecksumOfByte_Loop
	ror d0	;Routieren geht durch Carry-Bit(->Registerweite 9 Bit), daher 
		;abschlieend noch einmal Routieren
	pop d2
	ret




CheckBaudRate:
	



CheckHC06BaudRate:
	ldi d0, 'A'
	rcall TxDSendByte
	rcall wait25m

	ldi d0, 'T'
	rcall TxDSendByte
	rcall wait25m
CheckHC06BaudRate_Wait:
	lds d0, UCSR0A
	sbrs d0, RXC0
	jmp CheckHC06BaudRate_Wait
	
	
		
	lds d0, UDR0 // Get received byte in d0
	cpi d0, 'O'
	brne CheckHC06BaudRate_End
	//call SETLED1

CheckHC06BaudRate_End:
	//call SETLED2
	ret

